/* IN PROGRESS */
/* Default linker script, for an application */
OUTPUT_FORMAT("coff-h8300")
OUTPUT_ARCH(h8300s)
ENTRY("_start")

MEMORY
{
	/* 0xc4 is a magic entry.  We should have the linker just
	   skip over it one day...  */
	vectors : o = 0x0000, l = 0x16f
	/* what are magicvectors??? */
	magicvectors : o = 0x16f, l = 0x16f
	/* Cybiko Classic has 256K ram starting at 0x20000 */
	ram    : o = 0x200000, l = 0x40000
	/* The stack starts at the top of on-chip-RAM. Says me! */
	topram : o = 0xfffbfc, l = 0x4
	/* This holds variables in the "tiny" sections.  */
	tiny   : o = 0xffec00, l = 0x0200
	/* Address space for the 8-bit area.  */
	eight  : o = 0xffee00, l = 0x0200
}

SECTIONS
{
.vectors :
	{
	  /* there is a vector table somewhere in the cybiko memory space
		need to find it */
	  /* Use something like this to place a specific
	     function's address into the vector table.
	     LONG (ABSOLUTE (_foobar)).  */
	  *(.vectors)
	}  > vectors
.text :
	{
	  *(.text)
	  *(.rodata)
	  *(.strings)
   	   _etext = . ;
	}
.tors :
	{
	  ___ctors = . ;
	  *(.ctors)
	  ___ctors_end = . ;
	  ___dtors = . ;
	  *(.dtors)
	  ___dtors_end = . ;
	}
.data :
	{
	  *(.data)
	   _edata = . ;
	}
.bss :
	{
	   _bss_start = . ;
	  *(.bss)
	  *(COMMON)
	   _end = . ;
	}
.stack :
	{
	   _stack = . ;
	  *(.stack)
	}
.tiny :
	{
	  *(.tiny)
	}
.eight :
	{
	  *(.eight)
	}  > eight
.stab 0 (NOLOAD) :
	{
	  [ .stab ]
	}
.stabstr 0 (NOLOAD) :
	{
	  [ .stabstr ]
	}
}
