
#ifndef _FILEOPS_H_
#define _FILEOPS_H_

#include "filesys.h"



typedef UINT16  PageT;


typedef struct
{
    PageT   page;       // what physical page are we on
    long    offset;     // what offset in the page will we read next
    long    logical;    // The logical position (eg returned to tell)
} PositionT;



typedef enum
{
    FILE_SEEK_SET,
    FILE_SEEK_CUR,
    FILE_SEEK_END,
} FileSeekT;



// Incomplete Data Type for a file
typedef struct *FileT;


// All of the data for the file needs to be filled in
// A pointer is returned for the file
// Check and qualify then call the right
StatusT FileOpen(FileT *file, PathT path, FileFlagsT flags);


// What is the position
StatusT FileTell(FileT file, size_t *position);


// This is the API for removing a file
StatusT FileDelete(PathT *path);


// move the position somewhere - need to qualify?
StatusT FileSeek(FileT file, size_t offset, FileSeekT type);

// not an error to flush a read only file - but does nothing
StatusT FileFlush(FileT file);


StatusT FileClose(FileT file);

StatusT FileRead(FileT file, UINT8 *buffer, size_t *size);



// end of header file
#endif
