#ifndef _RECT_H_
#define _RECT_H_


// Rect is guaranteed in order!!
typedef struct
{
    short   x;
    short   y;
    short   w;
    short   h;
} RectT, *pRectT;



// Bounds is like a rect, but in absolute coords
// Use the bounds in sprite bounce, etc
typedef struct
{
    short   left;
    short   right;
    short   top;
    short   bottom;
} BoundsT, *pBoundsT;





void RectMake(RectT *rect, short x, short y, short x2, short y2);

short RectInside(RectT *src, short x, short y);

// do these rectangles intersect? - useful for collision detection
// 1 = collision
short RectCollide(RectT *rect, RectT *rect2);


#endif

