#ifndef _SFX_H_
#define _SFX_H_




// use these with _sound(SFX_MIDI_69); // to play an 'A' = 440Hz

#define SFX_MIDI_0      42271   // C - very low Freq ~ 8Hz
#define SFX_MIDI_1      39899   // Db
#define SFX_MIDI_2      37659   // D
#define SFX_MIDI_3      35546   // Eb
#define SFX_MIDI_4      33551   // E
#define SFX_MIDI_5      31668   // F
#define SFX_MIDI_6      29890   // Gb
#define SFX_MIDI_7      28213   // G
#define SFX_MIDI_8      26629   // Ab
#define SFX_MIDI_9      25135   // A
#define SFX_MIDI_10     23724   // Bb
#define SFX_MIDI_11     22392   // B
#define SFX_MIDI_12     21136   // C  ~16Hz
#define SFX_MIDI_13     19949
#define SFX_MIDI_14     18830
#define SFX_MIDI_15     17773
#define SFX_MIDI_16     16775
#define SFX_MIDI_17     15834
#define SFX_MIDI_18     14945
#define SFX_MIDI_19     14106
#define SFX_MIDI_20     13315
#define SFX_MIDI_21     12567
#define SFX_MIDI_22     11862
#define SFX_MIDI_23     11196
#define SFX_MIDI_24     10568
#define SFX_MIDI_25     9975
#define SFX_MIDI_26     9415
#define SFX_MIDI_27     8886
#define SFX_MIDI_28     8388
#define SFX_MIDI_29     7917
#define SFX_MIDI_30     7473
#define SFX_MIDI_31     7053
#define SFX_MIDI_32     6657
#define SFX_MIDI_33     6284    // A = 55Hz
#define SFX_MIDI_34     5931
#define SFX_MIDI_35     5598
#define SFX_MIDI_36     5284
#define SFX_MIDI_37     4987
#define SFX_MIDI_38     4707    // notes lower dont sound too good...
#define SFX_MIDI_39     4443
#define SFX_MIDI_40     4194
#define SFX_MIDI_41     3958
#define SFX_MIDI_42     3736
#define SFX_MIDI_43     3527
#define SFX_MIDI_44     3329
#define SFX_MIDI_45     3142    // A = 110Hz
#define SFX_MIDI_46     2965
#define SFX_MIDI_47     2799
#define SFX_MIDI_48     2642
#define SFX_MIDI_49     2494
#define SFX_MIDI_50     2354
#define SFX_MIDI_51     2222
#define SFX_MIDI_52     2097
#define SFX_MIDI_53 1979
#define SFX_MIDI_54 1868
#define SFX_MIDI_55 1763
#define SFX_MIDI_56 1664
#define SFX_MIDI_57 1571    // A = 220Hz
#define SFX_MIDI_58 1483
#define SFX_MIDI_59 1400
#define SFX_MIDI_60 1321
#define SFX_MIDI_61 1247
#define SFX_MIDI_62 1177
#define SFX_MIDI_63 1111
#define SFX_MIDI_64 1048
#define SFX_MIDI_65 990
#define SFX_MIDI_66 934
#define SFX_MIDI_67 882
#define SFX_MIDI_68 832
#define SFX_MIDI_69 785     // A = 440Hz
#define SFX_MIDI_70 741
#define SFX_MIDI_71 700
#define SFX_MIDI_72 660
#define SFX_MIDI_73 623
#define SFX_MIDI_74 588
#define SFX_MIDI_75 555
#define SFX_MIDI_76 524
#define SFX_MIDI_77 495
#define SFX_MIDI_78     467 // Gb ~ 740Hz
#define SFX_MIDI_79 441
#define SFX_MIDI_80 416
#define SFX_MIDI_81     393 // A = 880Hz
#define SFX_MIDI_82 371
#define SFX_MIDI_83 350
#define SFX_MIDI_84 330
#define SFX_MIDI_85 312
#define SFX_MIDI_86 294
#define SFX_MIDI_87 278
#define SFX_MIDI_88 262
#define SFX_MIDI_89 247
#define SFX_MIDI_90 234
#define SFX_MIDI_91 220
#define SFX_MIDI_92 208
#define SFX_MIDI_93     196 // A = 1760Hz
#define SFX_MIDI_94 185
#define SFX_MIDI_95 175
#define SFX_MIDI_96     165 // C ~ 2093Hz
#define SFX_MIDI_97 156
#define SFX_MIDI_98 147
#define SFX_MIDI_99 139
#define SFX_MIDI_100 131
#define SFX_MIDI_101 124
#define SFX_MIDI_102 117
#define SFX_MIDI_103 110
#define SFX_MIDI_104 104
#define SFX_MIDI_105    98  // A = 3520Hz
#define SFX_MIDI_106 93
#define SFX_MIDI_107 87
#define SFX_MIDI_108    83  // C ~ 4186Hz
#define SFX_MIDI_109 78
#define SFX_MIDI_110 74
#define SFX_MIDI_111 69
#define SFX_MIDI_112 66
#define SFX_MIDI_113 62
#define SFX_MIDI_114 58
#define SFX_MIDI_115 55
#define SFX_MIDI_116 52
#define SFX_MIDI_117    49  // A = 7040Hz
#define SFX_MIDI_118 46
#define SFX_MIDI_119 44
#define SFX_MIDI_120 41
#define SFX_MIDI_121 39
#define SFX_MIDI_122 37
#define SFX_MIDI_123 35
#define SFX_MIDI_124 33
#define SFX_MIDI_125 31
#define SFX_MIDI_126 29
#define SFX_MIDI_127 28


typedef signed short MidiNoteT;
typedef unsigned char BeatTicksT;

// This is a simple tone generator! Only one note! It will play in the
// background. A sound can be played over it, but the next note will restore
// song and could cut off the tone.

// Everything is in 4/4 time.
// Each quarter note gets one beat

// then a whole         note is 4 beats     (32 32nds)
// then a half          note is 2 beats     (16 32nds)
// then a quarter       note is 1 beat      (8 32nds)
// then a eighth        note is             (4 32nds)
// then a sixteenth     note is             (2 32nds)
// then a thirtysecond  note is             (1 32nd)


typedef struct
{
    MidiNoteT   note;     // this is the number of the note
    BeatTicksT  ticks;    // how many ticks this gets
} MusicNoteT;



#define TICKS_PER_BEAT (32)
#define BEATS2TICKS(beats) (beats * TICKS_PER_BEAT)


// stop playing sounds
void SfxStop(void);

// play a music note - a value of 255 (0xff) is silence
void SfxNote(MusicNoteT *note);

// a note of 0 and tick of 0 is the end of the song
// times = how many times to play the song, 0 equals forever
void SfxSong(MusicNoteT *song, unsigned times);


#endif
