#include "stdlib.h"

// use capital ABCDEF
extern const char asciiX[];


// integer to ascii
// buffer must be long enough to hold entire result
// radix must be greater than 1 and less than 17
char *itoa(long value, char *buffer, int radix)
{
    char stack[32];
    char *returnptr = buffer;

    // check for a valid radix
    if (radix < 2 || radix > 16)
    {
        *buffer++ = 'E';
        *buffer = '\0';
    }
    else
    {
        char *push = stack;

        // gather the sign
        if (value < 0)
        {
            *buffer++ = '-';
            value = -value;
        }

        // convert and push the results
        do
        {
            *push++ = asciiX[value % radix];
            value /= radix;
        } while (value);

        // now pop the stack to the output
        do
        {
            *buffer++ = *--push;
        } while (push != stack);

        // terminate the string
        *buffer = '\0';
    }

    return returnptr;
}


