#ifndef _MALLOC_H_
#define _MALLOC_H_




/* memory pool structure definition */
struct __mp__
{
    struct __mp__    *next;        /* single-linked list */
    size_t            len;        /* length of following block */
};



/*  Memory pool header:  __mp__ points to the first available.
 *
 *  Note that the list is maintained in address order.  __mp__ points to the
 *  block with the lowest address.  That block points to the block with the
 *  next higher address and so on.                                          */

#define HLEN (sizeof(struct __mp__))
#define MALLOC_MIN_BLOCK (HLEN * 4)


#endif

