


#define BIN1_SIZE   32
#define BIN1_COUNT  1024

#define BIN2_SIZE   128
#define BIN2_COUNT  256

#define BIN3_SIZE   512
#define BIN3_COUNT  64

#define BIN4_SIZE   2048
#define BIN4_COUNT  16

#define BIN5_SIZE   8192
#define BIN5_COUNT  4

#define BIN6_SIZE   32768
#define BIN6_COUNT  1



struct
{
    unsigned    flags;
    char        space[BIN1_SIZE];
} bin1[BIN1_COUNT];

struct
{
    unsigned    flags;
    char        space[BIN2_SIZE];
} bin2[BIN2_COUNT];

struct
{
    unsigned    flags;
    char        space[BIN3_SIZE];
} bin3[BIN3_COUNT];

struct
{
    unsigned    flags;
    char        space[BIN4_SIZE];
} bin4[BIN4_COUNT];

struct
{
    unsigned    flags;
    char        space[BIN5_SIZE];
} bin5[BIN5_COUNT];

struct
{
    unsigned    flags;
    char        space[BIN6_SIZE];
} bin6[BIN6_COUNT];



typedef struct
{
    unsigned        size;   // how large are the bins
    unsigned        count;  // how many entries in the block
    unsigned        last;   // last bin used
    MallocBlockT    *bins;  // pointer to the bins 
} MallocCtrlT;




void *GetNextOpen(MallocCtrlT *block)
{
    unsigned index;


    index = block->last + 1;

    if (index >= block->count)
    {
        index = 0;
    }
    

    while (index != block->count)
    {
        // free?
        if (block->bins[index].flags == 0)
        {
            block->bins[index].flags = 1;
            block->last = index;
            return block->bins[index].space;
        }
    }

    return (void *)0;
}



// use functions specific to size because apriori knowledge helps alot
void *GetNextBin1(void)
{
    static unsigned last;
    unsigned index;

    index = last + 1;
    if (index >= BIN1_SIZE)
    {
        index = 0;
    }
    
    // search them all - from last
    while (index != last)
    {
        // free?
        if (block1[index].flags == 0)
        {
            block1[index].flags = 1;
            last = index;
            return block1[index].space;
        }

        index = last + 1;
        if (index >= BIN1_COUNT)
        {
            index = 0;
        }
    }

    return (void *)0;
}







void *malloc(size_t size)
{
    unsigned bin;
    void *ThisBin;


    if (size <= BIN1_SIZE)
    {
        ThisBin = GetNextBin(Block1);
        if (ThisBin == 0)
        {
            return GetNextBin(Block2);
        }
        else
        {
            return ThisBin;
        }
    }
    else

    while (block < MALLOC_BLOCKS)
    {
        if (size <= blocks[block].size)
        {
            // since the blocks are arranged by size, start at the smallest
            return GetNextOpen(block);
        }
        block++;
    }

    // size is too big!
    return 0;
}


        
