// Cyborn Library (c) 2004 Gotthardt Designs



void *
memmove(void *src1, const void *src2, unsigned long size)
{
    char *dst = (char *)src1;
    const char *src = (const char *)src2;

    if ((src < dst) && (dst < (src + size)))
    {
        // Copy backwards
        src += size;
        dst += size;

        while (size--)
        {
            *--dst = *--src;
        }
    }
    else
    {
        while (size--)
        {
            *dst++ = *src++;
        }
    }

    return src1;
}


