/***********************************************************************/
/*  This file is part of the C166 Compiler package                     */
/*  Copyright KEIL ELEKTRONIK GmbH 1993 - 1999                         */
/***********************************************************************/
/*                                                                     */
/*  REALLOC.C:                                                         */
/*                                                                     */
/*  To translate this file use C166 with the following invocation:     */
/*                                                                     */
/*     C166 REALLOC.C  <memory model>                                  */
/*                                                                     */
/*  To link the modified REALLOC.OBJ file to your application use the  */
/*  following L166 invocation:                                         */
/*                                                                     */
/*     L166 <your object file list>, REALLOC.OBJ <controls>            */
/*                                                                     */
/***********************************************************************/

#include <string.h>
#include <stdlib.h>
#include "malloc.h"




void *realloc (void *oldp, size_t size)
{
#define p   ((struct __mp__ *) oldp)
#define p0  ((struct __mp__ *)&p[-1]) /* block to realloc */

    void *newp;

    // get a new size
    newp = malloc(size);
    if (!newp) return (NULL);

    if (oldp)
    {
        if (size > p0->len)
        {
            size = p0->len;
        }

        memcpy(newp, oldp, size);
        free(oldp);
    }

    return (newp);
}

