;
;    Cyborn OS - Copyright (C) 2004 Steve Gotthardt - Gotthardt Designs
;
;    This file is part of the Cyborn distribution.
;
;    Cyborn is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    Cyborn is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with Cyborn; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;    A special exception to the GPL can be applied should you wish to distribute
;    a combined work that includes Cyborn, without being obliged to provide
;    the source code for any proprietary components.
;

    ;the dataflash is AT45DB041A - atmel dataflash


    ; long read(char *to, unsigned from, long count)
    ; to - is a data buffer that will hold at least count
    ; from - place in memory to read from
    ; count - how many to read
    ; the return value is the number of bytes actually read


    ; write(unsigned to, char *from, long count)


    ; the default state of the h8 syncro clock is high


    .h8300s
    .text

    .global __df_read
;    .global __df_write

    .set AT45DB041A_OP_READ,    0x68
    .set AT45DB041A_OP_WRITE,   0x6



    ; The data flash has 2 buffers, they can be read, written independantly
    ; The transfer to main memory can only be done one at a time. While the
    ; main memory is busy, the other buffer can be used.

    ;;;;Operation Mode Summary
    ;The modes described can be separated into two groups 
    ;modes which make use of the Flash memory array (Group A)
    ;and modes which do not make use of the Flash memory array (Group B).
    ;Group A modes consist of:
    ;1. Main Memory Page Read
    ;2. Main Memory Page to Buffer 1 (or 2) Transfer
    ;3. Main Memory Page to Buffer 1 (or 2) Compare
    ;4. Buffer 1 (or 2) to Main Memory Page Program with Built-in Erase
    ;5. Buffer 1 (or 2) to Main Memory Page Program without Built-in Erase
    ;6. Page Erase
    ;7. Block Erase
    ;8. Main Memory Page Program through Buffer
    ;9. Auto Page Rewrite

    ;Group B modes consist of:
    ;1. Buffer 1 (or 2) Read
    ;2. Buffer 1 (or 2) Write
    ;3. Status Register Read

    ;If a Group A mode is in progress (not fully completed) then
    ;another mode in Group A should not be started. However,
    ;during this time in which a Group A mode is in progress,
    ;modes in Group B can be started.
    ;This gives the Serial DataFlash the ability to virtually
    ;accommodate a continuous data stream. While data is
    ;being programmed into main memory from buffer 1, data
    ;can be loaded into buffer 2 (or vice versa).


    ; Initialize the SCI
__df_init:
    ; set the registers for the serial interface
    ; baud rate, sync mode,
    ; set the registers for the DTC - connect to onboard RAM
    ; The receive complete vector is at:                        0x00FFFBD0
    ; The transmit data empty vector is at the SAME as receive: 0x00FFFBD0
    ; Fill in the empty spaces in the vector
    ; Make another DTC entry after FFFBD0 at FFFBDC. Chain the first in to the
    ; other so that the writes into SI finishes and then the reads are made


__df_read:
    ;fill opcode buffer
;    mov     AT45DB041A_OP_READ, opcode[xxx]
 ;   mov     erx,                opcode[xxx]
  ;  mov     ery,                opcode[xxx]
   ; mov     erz,                opcode[xxx]
    ; the other opcode entries are all zeros - 4 bytes - 32 dont care bits

    rts
