#ifndef _DATAFLASH_H_
#define _DATAFLASH_H_

// bits
#define AT45DB041A_STATUS_READY 0x80
#define AT45DB041A_STATUS_COMP  0x40

// mask off the size bits
#define AT45DB041A_SIZE_MASK    0x38
#define DATAFLASH_SIZE_4M       0x18

#define DATAFLASH_SIZE_MASK     AT45DB041A_SIZE_MASK


#define CLOCK_IDLES             (1)
#define CLOCK_SPI               (0)

// what logic level does the H8S clock idle at -> high
#define H8S_SCI_CLOCK           CLOCK_IDLES

#define CLOCK_TYPE              H8S_SCI_CLOCK

// opcodes
#if (CLOCK_TYPE == CLOCK_IDLES)
#define DATAFLASH_OP_READMAIN   (0x68)
#define DATAFLASH_OP_READPAGE   (0x52)
#define DATAFLASH_OP_READB1     (0x54)
#define DATAFLASH_OP_READB2     (0x56)
#define DATAFLASH_OP_STATUS     (0x57)
#endif

#define DATAFLASH_OP_WRITEB1    (0x84)
#define DATAFLASH_OP_WRITEB2    (0x87)
#define DATAFLASH_OP_B1PAGEE    (0x83)
#define DATAFLASH_OP_B2PAGEE    (0x86)
#define DATAFLASH_OP_B1PAGE     (0x88)
#define DATAFLASH_OP_B2PAGE     (0x89)
#define DATAFLASH_OP_PAGEE      (0x81)
#define DATAFLASH_OP_BLOCKE     (0x50)
#define DATAFLASH_OP_MAINPB1    (0x82)
#define DATAFLASH_OP_MAINPB2    (0x85)



#define DATAFLASH_PAGE_SIZE      (264)


// NOT IMPLEMENTED YET
//void DataFlashReadPage(unsigned page, char *buffer);
//void DataFlashWritePage(unsigned page, char *buffer);
//void DataFlashInit(void);



#endif
