;
;    Cyborn OS - Copyright (C) 2004 Steve Gotthardt - Gotthardt Designs
;
;    This file is part of the Cyborn distribution.
;
;    Cyborn is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    Cyborn is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with Cyborn; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;    A special exception to the GPL can be applied should you wish to distribute
;    a combined work that includes Cyborn, without being obliged to provide
;    the source code for any proprietary components.
;


    .h8300s
    .text

    .global __pixelset

    ;structure offsets - need to match with lowlevel.h
    .set screen,    0
    .set xx,        4
    .set yy,        5
    .set color,     6
    .set mode,      7



;NOTE: do not use RMW commands on write only registers like the DDR for ports!
;NOTE: modules must be enabled first or the registers are dead


;equation is the same: 40y + x/4 = (160y + x) / 4

.if 0
;er0 - pointer to context
; r1l - x
; r2l - y
_GfxPixel:
    mov     #160,           r2h     ;load 160 (40 * 4)
    mulxu   r2h,            r2      ;mult the y by 160 - max of 160 * 100
    add     r1l             r2      ;add x (max of 160)
    shlr    #2,             r2      ;index of the byte
    extu    er2                     ;er2 contains the 32bit index

    mov     @(4:16, er0),   r1h     ;put the color someplace
    mov     @er0,           er0     ;address of screen
    add     er2,            er0     ;er0 has effective address of byte


    and     #3,             r1l     ;take last 3 bits of x
    mov     @er0,           r2l     ;THE byte


    add     r3,             r1      ;
    shlr    #2,             r1
    extu    er1
    mov     @er0,           er3     ;get the pointer to screen
    add     er1,            er3     ;now have the absolute address to byte

.endif


    ;er0 is a pointer to the display context
__pixelset:
    mov     #40,            r1h     ;figure how many rows - 40 bytes per row
    mov     @(yy:16,er0),   r1l     ;get y
    mulxu   r1h,            r1      ;multiply the y by number of bytes in row

    ;r1 now has y * 40    - add x/4 into it
    mov     @(xx:16,er0),   r3l     ;get x
    shlr    #2,             r3l     ;divide x by 4
    extu    r3                      ;use whole word
    add     r3,             r1      ;add to y * 40
    extu    er1                     ;er1 has the offset from the screen
    mov     @er0,           er3     ;get the pointer to screen
    add     er1,            er3     ;now have the absolute address to byte

    mov     @(xx:16,er0),   r2l     ; get x
    and     #3,             er2     ; strip to 2 bits
    mov     @(_gfxpixelnotch:32,er2),r2h     ; get the mask

    
    mov     @er3,           r2l     ;get the target byte
    and     r2h,            r2l     ;cleared out target pixel

    mov     @(color:16,er0),r0l     ;get color request from pointer
    not                     r2h     ; make a notch mask
    and     r2h,            r0l     ; pick the color out

    or      r2l,            r0l     ; or in set color

    mov     r2l,            @er3    ;store byte back to the screen

    rts

