#include "types.h"
#include "lowlevel.h"



// Read the keyboard and report the keys as real ascii
// The keypad has to be scanned
// The shift key and function key have to scanned and detected



// There should be a scan with intellegence
// The keys are read by addressing an area of memory
// Turn the keyscan into an ASCII key
// Note that this also returns special keys - ASCII is < 0x80
// The function key is ignored, but can be checked: _keycheck(RAW_KEY_FN)
// The fn key and shift cannot be used together
KeyT asciikey(void)
{
    KeyT    Key;

    // call the lowest level function to scan the keypad into raw output
    Key = _rawkey();

    // get the ASCII from the raw conversion table - shifted or not
    if (_keycheck(RAW_KEY_SHIFT))
    {
        Key = raw2asciiSHIFTED[Key];
    }
    else
    {
        Key = raw2ascii[Key];
    }

  
    return Key;
    
}



// see lowlevel.h
// read the joystick fast with multiple key detection - this allows getting a
// up and right, up and left, dn and right, dn and left as well as u, d, l, r
JoystickT joystick(void)
{
    JoystickT   joy = 0;

    // check left or right
    if (_keycheck(RAW_KEY_AL)) 
    {
        joy |= KEY_JOY_LEFT;
    }
    else if (_keycheck(RAW_KEY_AR)) 
    {
        joy |= KEY_JOY_RIGHT;
    }

    // only need to check one or the other:
    if (_keycheck(RAW_KEY_AU))
    {
        joy |= KEY_JOY_UP;
    }
    else if (_keycheck(RAW_KEY_AD)) 
    {
        joy |= KEY_JOY_DOWN;
    }
    

    return joy;
}

   



