;
;    Cyborn OS - Copyright (C) 2004 Steve Gotthardt - Gotthardt Designs
;
;    This file is part of the Cyborn distribution.
;
;    Cyborn is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    Cyborn is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with Cyborn; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;    A special exception to the GPL can be applied should you wish to distribute
;    a combined work that includes Cyborn, without being obliged to provide
;    the source code for any proprietary components.
;
;NOTE: do not use RMW commands on write only registers like the DDR for ports!
;NOTE: modules must be enabled first or the registers are dead


    .h8300s
    .text


    ;exported functions for controlling the leds
    .global __ledgreenon
    .global __ledgreenoff
    .global __ledredon
    .global __ledredoff

    .set P2DATA,        0x61
    .set GREEN_BIT,     3
    .set RED_BIT,       2



; The Red LED is also controlled by the charger - when the charger is plugged in
; the led will turn on - there is no way to turn it off.
; The Red LED will get a little brighter when turned on though...
; NOTE: this assumes that the P2 data direction is set for output for these.
;  The bootloader does this for us.

; Turn on the green LED
__ledgreenon:
    bset    #GREEN_BIT,     @P2DATA:8
    rts

; Turn off the green LED
__ledgreenoff:
    bclr    #GREEN_BIT,     @P2DATA:8
    rts

; Turn on the red LED
__ledredon:
    bset    #RED_BIT,       @P2DATA:8
    rts

; Turn off the red LED
; The red led cannot be turned off when the charger is on and plugged in
; It will get a little dimmer if it was asserted on and then turned off
__ledredoff:
    bclr    #RED_BIT,       @P2DATA:8
    rts


