// Special Cybiko Keys - no ASCII equivalent
// Function Keys
#define KEY_F1  0x81
#define KEY_F2  0x82
#define KEY_F3  0x83
#define KEY_F4  0x84
#define KEY_F5  0x85
#define KEY_F6  0x86
#define KEY_F7  0x87

// Arrow keys
#define KEY_LEFT    0xF0
#define KEY_RIGHT   0xF1
#define KEY_UP      0xF2
#define KEY_DOWN    0xF3

// special keys
#define KEY_INSERT  0xFC
#define KEY_HELP    0xFD
#define KEY_SELECT  0xFE
#define KEY_DELETE  0xFF


// 

// use this array to convert a raw key into its ascii equivalant
const unsigned char raw2ascii[] =
{
    0x00,           // 0    - Nothing
    KEY_F7,         // 1    - F7
    0x00,           // 2    - this was an 'esc'
    KEY_DELETE,     // 3    - Delete Key
    KEY_LEFT,       // 4    - Left Arrow 
    'q',            // 5    - 
    'a',            // 6    - 
    '`',            // 7    - grave
    0x00,           // 8    - Shift Key
    KEY_F6,         // 9    - F6
    KEY_UP,         // 10   - Up Arrow
    KEY_INSERT,     // 11   - Insert
    '2',            // 12   - 
    'w',            // 13   -
    's',            // 14   -
    'z',            // 15   -
    0x00,           // 16   - Function Key
    KEY_F5,         // 17   - F5
    KEY_F3,         // 18   - F3
    ' ',            // 19   - space
    '3',            // 20   -
    'e',            // 21   -
    'd',            // 22   -
    'x',            // 23   -
    KEY_HELP,       // 24   - help
    KEY_F4,         // 25   - F4
    '1',            // 26   -
    '\t',           // 27   - tab
    '4',            // 28   -
    'r',            // 29   -
    'f',            // 30   -
    'c',            // 31   - 
    '[',            // 32   - left bracket
    KEY_RIGHT,      // 33   - right arrow
    KEY_DOWN,       // 34   - down arrow
    KEY_SELECT,     // 35   - select
    '5',            // 36   -
    't',            // 37   -
    'g',            // 38   -
    'v',            // 39   -
    ']',            // 40   - right bracket
    KEY_F2,         // 41   - F2
    ';',            // 42   - semicolon
    '\r',           // 43   - enter - return
    '6',            // 44   -
    'y',            // 45   -
    'h',            // 46   -
    'b',            // 47   -
    '\\',           // 48   - backslash
    KEY_F1,         // 49   - F1
    '/',            // 50   - forward slash
    '\b',           // 51   - backspace
    '7',            // 52   - 
    'u',            // 53   - 
    'j',            // 54   - 
    'n',            // 55   - 
    0x00,           // 56   - 
    '-',            // 57   - dash
    '.',            // 58   - period
    '0',            // 59   - 
    '8',            // 60   - 
    'i',            // 61   - 
    'k',            // 62   - 
    'm',            // 63   - 
    0x00,           // 64   - 
    '\'',           // 65   - single quote
    '=',            // 66   - equal
    '9',            // 67   - 
    'p',            // 68   - 
    'o',            // 69   - 
    'l',            // 70   - 
    ',',            // 71   - comma
};    

// use this array to convert a raw key into its ascii equivalant
const unsigned char raw2asciiSHIFTED[] =
{
    0x00,           // 0    - Nothing
    KEY_F7,         // 1    - F7
    0x00,           // 2    -
    KEY_DELETE,     // 3    - Delete Key
    KEY_LEFT,       // 4    - Left Arrow 
    'Q',            // 5    - Q
    'A',            // 6    - A
    '~',            // 7    - tilde
    0x00,           // 8    - Shift Key
    KEY_F6,         // 9    - F6
    KEY_UP,         // 10   - Up Arrow
    KEY_INSERT,     // 11   - Insert
    '@',            // 12   - at sign
    'W',            // 13   -
    'S',            // 14   -
    'Z',            // 15   -
    0x00,           // 16   - Function Key
    KEY_F5,         // 17   - F5
    KEY_F3,         // 18   - F3
    ' ',            // 19   - space
    '#',            // 20   - pound sign
    'E',            // 21   -
    'D',            // 22   -
    'X',            // 23   -
    KEY_HELP,       // 24   - help
    KEY_F4,         // 25   - F4
    '!',            // 26   - Shift 1
    '\t',           // 27   - tab
    '$',            // 28   - Shift 4
    'R',            // 29   -
    'F',            // 30   -
    'C',            // 31   - 
    '{',            // 32   - left brace
    KEY_RIGHT,      // 33   - right arrow
    KEY_DOWN,       // 34   - down arrow
    KEY_SELECT,     // 35   - select
    '%',            // 36   - percent
    'T',            // 37   -
    'G',            // 38   -
    'V',            // 39   -
    '}',            // 40   - right brace
    KEY_F2,         // 41   - F2
    ':',            // 42   - colon
    '\r',           // 43   - enter
    '^',            // 44   - carat
    'Y',            // 45   -
    'H',            // 46   -
    'B',            // 47   -
    '|',            // 48   - pipe
    KEY_F1,         // 49   - F1
    '?',            // 50   - questionmark
    '\b',           // 51   - backspace
    '&',            // 52   - ampersand
    'U',            // 53   - 
    'J',            // 54   - 
    'N',            // 55   - 
    0x00,           // 56   - 
    '_',            // 57   - underbar
    '>',            // 58   - greater than
    ')',            // 59   - right paren
    '*',            // 60   - asterisk
    'I',            // 61   - 
    'K',            // 62   - 
    'M',            // 63   - 
    0x00,           // 64   - 
    '\"',           // 65   - double quote
    '+',            // 66   - plus
    '(',            // 67   - left paren
    'P',            // 68   - 
    'O',            // 69   - 
    'L',            // 70   - 
    '<',            // 71   - less than
};    

