;
;    Cyborn OS - Copyright (C) 2004 Steve Gotthardt - Gotthardt Designs
;
;    This file is part of the Cyborn distribution.
;
;    Cyborn is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    Cyborn is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with Cyborn; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;    A special exception to the GPL can be applied should you wish to distribute
;    a combined work that includes Cyborn, without being obliged to provide
;    the source code for any proprietary components.
;




;;;;; NOTE: This sound driver cannot be used with others that try and drive
;;;;;;;;;;; the same pin! ie PWM  !


    .h8300s
    .text

    .global __sound
    .global __soundoff
    .global __soundinit



    .set PORT1DDR, 0xFFFEB0
    .set PORT1DATA, 0x60
    .set PORT1PINS, 0x50

    .set TSTR,      0xC0    ; for all counters / TPUs
    .set TSYR,      0xC1
    .set MSTPCR,    0xFF3C    ;word

    .set TCR1,      0xE0
    .set TMDR1,     0xE1
    .set TIOR1,     0xE2
    .set TIER1,     0xE4
    .set TSR1,      0xE5
    .set TCNT1,     0xFFE6    ;word
    .set TGR1A,     0xFFE8    ;word
    .set TGR1B,     0xFFEA    ;word


;NOTE: do not use RMW commands on write only registers like the DDR for ports!
;NOTE: modules must be enabled first or the registers are dead

__soundinit:
    mov     @MSTPCR:16,     r1
    and     #0xDF,  r1h
    mov     r1,     @MSTPCR:16

    ;need to set up sound - TCR1
    bclr    #1,     @TSTR:8     ;make sure counting is off
    mov     #0x42,  r1l         ;divide by 16 - makes midi tones better
    mov     r1l,    @TCR1:8

    mov     #0xC0,  r1l         ;normal operation
    mov     r1l,    @TMDR1:8

    ;set the tgr1 b to toggle output at compare match - makes period * 2
    bset    #4,     @TIOR1:8
    bset    #5,     @TIOR1:8
    rts




__sound:
    ;set the B register for compare
    mov     r0,     @TGR1B:16
    sub     r0,     r0

    ;clear the counter so it starts over for the new sound
    mov     r0,     @TCNT1:16

    ;enable counting
    bset    #1,     @TSTR:8
    rts



__soundoff:
    bclr    #1,     @TSTR:8
    rts


