typedef long fixed;			// Our new fixed point type.

#define itofx(x) ((x) << 8)			// Integer to fixed point
#define ftofx(x) ((x) * 256)			// Float to fixed point
#define dtofx(x) ((x) * 256)			// Double to fixed point
#define fxtoi(x) ((x) >> 8)			// Fixed point to integer
#define fxtof(x) ((float) (x) / 256)		// Fixed point to float
#define fxtod(x) ((double)(x) / 256)	        // Fixed point to double
#define Mulfx(x,y) (((y) * (x)) >> 8)		// Multiply a fixed by a fixed
#define Divfx(x,y) ((y << 8) / (x))    		// Divide a fixed by a fixed
#define Printfx(x) printf("%ld.%ld", x >> 8, 100 * (unsigned long) ((x) & 0x00ff) >> 8)
// Print fixed point.
#define NDPrintfx(x) printf("%ld", x >> 8)
// Print fixed point without a decimal point.



#ifdef USE_FIXEDPOINT

// setup some defines to sacrifice some floating precicision
// during multiplication
#define FP_PREC_4 FP_PREC/4
#define FP_PREC_REMAIN FP_PREC - (FP_PREC_4 + FP_PREC_4)
#define FP_PREC_MAX         (fpint)(1<< FP_PREC)
#define FP_MULT(a, b) (fpint)(((a>>FP_PREC_4)*(b>>FP_PREC_4)) >> (FP_PREC_REMAIN))

#define FP_ABS(n)			(fpint)( (n) & 0x80000000 ? ~(n)+1 : (n) )
#define FP_PARTS(n,d)		(fpint)( ((n) * 1 << FP_PREC) / d )
#define FP_NUMBER(f)		(fpint)((f) * (1 << FP_PREC))
#define FP_TO_FLOAT(fp)		(float)((float)(fp) / (float)(1 << FP_PREC))
#define FP_WHOLE_PART(fp)	(int)((fp) >> FP_PREC)
#define FP_DIV(a,b)			(fpint)(((a))/((b)>>FP_PREC))
#define FP_IS_NEGATIVE(fp)	((fp) & 0x8000000)
#define __FP_MATH_DEFINED
#else
#define FP_ABS(n)			fabs(n)
#define FP_PREC 15
#define FP_PARTS(n,d)		(float)((float)(n)/(float)(d))
#define FP_NUMBER(f)		(float)(f)
#define FP_TO_FLOAT(fp)		(float)(fp)
#define FP_WHOLE_PART(fp)	(int)(fp)
#define FP_MULT(a, b)		((a)*(b))
#define FP_DIV(a,b)			((a)/(b))
#define FP_IS_NEGATIVE(fp)	((fp)<0.f)
#define __FP_MATH_DEFINED
#endif // USE_FIXEDPOINT

