
#include <string.h>
#include "gfx.h"



void
GfxHLine(SurfaceT *surface, GfxPT x1, GfxPT y1, GfxPT x2)
{
    unsigned char *surfaceptr;
    unsigned char mask, left, right;

    unsigned char x1byte;
    unsigned char x2byte;

    if (x1 > x2)
    {
        // stupid byte hack to swap
        x1 ^= x2;
        x2 ^= x1;
        x1 ^= x2;
    }

    x1byte = x1 >> 2;
    x2byte = x2 >> 2;


    // are all of the changes in just one byte?
    if (x2byte == x1byte)
    {
        mask = gfxleftmask[x1 & 3] & gfxrightmask[x2 & 3];
        surfaceptr = surface->buffer + y1 * surface->cols + x1byte;
        *surfaceptr = (*surfaceptr & ~mask) | (surface->fgPattern & mask);
    }
    else
    {
        unsigned width;

        // do the ends of the line - first the right end
        right =  gfxrightmask[x2 & 3];
        surfaceptr = surface->buffer + y1 * surface->cols + x2byte;
        *surfaceptr = (*surfaceptr & ~right) | (surface->fgPattern & right);

        // now the left end
        left = gfxleftmask[x1 & 3];
        surfaceptr = surfaceptr - x2byte + x1byte;
        *surfaceptr = (*surfaceptr & ~left) | (surface->fgPattern & left);

        // if the line extends across more than 2 bytes, memset them
        width = x2byte - x1byte - 1;
        if (width)
        {
            memset(surfaceptr + 1, surface->fgPattern, width);
        }
    }
}




