//
//  Cyborn OS - Copyright (C) 2004 Steve Gotthardt - Gotthardt Designs
//
//  This file is part of the Cyborn distribution.
//
//  Cyborn is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  Cyborn is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with Cyborn; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//  A special exception to the GPL can be applied should you wish to distribute
//  a combined work that includes Cyborn, without being obliged to provide
//  the source code for any proprietary components.
//





#include "gfx.h"

#define sgn(x) ((x<0)?-1:((x>0)?1:0)) // macro to return the sign


#if 0
inline
short sgn(short val)
{
    if (val > 0)        return 1;
    else if (val < 0)   return -1;
    else                return 0;
}
#endif


#if 0
// found what is supposed to be faster
//http://64.233.161.104/search?q=cache:JUSMjXpCzQwJ:www.cs.ucl.ac.uk/staff/A.Steed/book_tmp/CGVE/slides/line-drawingB.ppt+fast+line+drawing&hl=en
    dx = x2 - x1;   
    dy = y2 - y1;

    yi = y1;    
    yf = -dx;

    for (x=x1; x<=x2; x++) 
    {
        if (yi > 0) 
        {
            yi++;
            yf += (2dy - 2dx);
        } 
        else 
        {
            yf += 2dy;
        }

        setPixel(x,yi);

    }

#endif 


void
GfxLine(SurfaceT *surface, GfxPT x1, GfxPT y1, GfxPT x2, GfxPT y2)
{
  short i,dx,dy,sdx,sdy,dxabs,dyabs,x,y,px,py;

  dx = x2-x1;      /* the horizontal distance of the line */
  dy = y2-y1;      /* the vertical distance of the line */
  dxabs = (dx>=0)? dx : -dx;
  dyabs = (dy>=0)? dy : -dy;
  sdx=sgn(dx);
  sdy=sgn(dy);
  x=dyabs>>1;
  y=dxabs>>1;
  px=x1;
  py=y1;


  if (dxabs>=dyabs) /* the line is more horizontal than vertical */
  {
    for(i=0;i<dxabs;i++)
    {
      y+=dyabs;
      if (y>=dxabs)
      {
        y-=dxabs;
        py+=sdy;
      }
      px+=sdx;
      GfxPixel(surface, px, py);
    }
  }
  else /* the line is more vertical than horizontal */
  {
    for(i=0;i<dyabs;i++)
    {
      x+=dxabs;
      if (x>=dyabs)
      {
        x-=dyabs;
        px+=sdx;
      }
      py+=sdy;
      GfxPixel(surface, px, py);
    }
  }
}




