//
//  Cyborn OS - Copyright (C) 2004 Steve Gotthardt - Gotthardt Designs
//
//  This file is part of the Cyborn distribution.
//
//  Cyborn is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  Cyborn is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with Cyborn; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//  A special exception to the GPL can be applied should you wish to distribute
//  a combined work that includes Cyborn, without being obliged to provide
//  the source code for any proprietary components.
//



#include "gfx.h"



void
GfxLine(SurfaceT *surface, GfxPT x1, GfxPT y1, GfxPT x2, GfxPT y2)
{
    int x, y;
    int dx, dy;
    int incx, incy;
    int balance;


    if (x2 >= x1)
    {
        dx = x2 - x1;
        incx = 1;
    }
    else
    {
        dx = x1 - x2;
        incx = -1;
    }

    if (y2 >= y1)
    {
        dy = y2 - y1;
        incy = 1;
    }
    else
    {
        dy = y1 - y2;
        incy = -1;
    }

    x = x1;
    y = y1;

    if (dx >= dy)
    {
        dy <<= 1;
        balance = dy - dx;
        dx <<= 1;

        while (x != x2)
        {
            GfxPixel(surface,x, y);
            if (balance >= 0)
            {
                y += incy;
                balance -= dx;
            }
            balance += dy;
            x += incx;
        }
        GfxPixel(surface,x, y);
    }
    else
    {
        dx <<= 1;
        balance = dx - dy;
        dy <<= 1;

        while (y != y2)
        {
            GfxPixel(surface,x, y);
            if (balance >= 0)
            {
                x += incx;
                balance -= dy;
            }
            balance += dx;
            y += incy;
        }
        GfxPixel(surface,x, y);
    }
}



