; Here are some nice tables to help mask bits - since these are located
; in ROM they are faster (access) and save memory (not much, but helps!)


.h8300s


// these masks are exported
.global _gfxpixelmask
.global _gfxleftmask
.global _gfxrightmask
.global _gfxcolormask
.global _gfxcolors
.global _gfxpixelnotch



.text



#ifdef BOOTROM117
.set    _gfxpixelmask,  0x6848

.set    _gfxleftmask,   0x684c

.set    _gfxrightmask,  0x6850

.set    _gfxcolors,     0x6854

; colors masks 4 sections of 4 bytes each
.set    _gfxcolormask,  0x6858

#else

_gfxpixelmask:
.byte 0xC0, 0x30, 0x0C, 0x03

_gfxleftmask:
.byte 0xFF, 0x3F, 0x0F, 0x03

_gfxrightmask:
.byte 0xC0, 0xF0, 0xFC, 0xFF

_gfxcolors:
.byte 0x00, 0x55, 0xAA, 0xFF

_gfxcolormask:
.byte 0x00, 0x00, 0x00, 0x00
.byte 0x40, 0x10, 0x04, 0x01
.byte 0x80, 0x20, 0x08, 0x02
.byte 0xC0, 0x30, 0x0C, 0x03


#endif

; couldn't find this one in the bootrom
_gfxpixelnotch:
.byte 0x3F, 0xCF, 0xF3, 0xFC


