
#include "gfx.h"
#include "rect.h"




void
PixmapBlit(GfxContextT  *context,   // graphics context
        unsigned        x,          // where to put the image
        unsigned        y,          //
        PixmapT         *src,       // pixmap source
        RectT           *rect)      // destination location
{
    unsigned destx;
    unsigned desty;

    // TODO: use monitor, etc to optimize this
    for (destx = 0; destx < rect->w; destx++)
    {
        for (desty = 0; desty < rect->h; desty++)
        {
            switch (PixmapColor(src, rect->x + destx, rect->y + desty))
            {
                case GFX_COLOR_BLK:
                    GfxPixelX(context, x + destx, y + desty, GFX_COLOR_BLK);
                    break;

                case GFX_COLOR_LTG:
                    GfxPixelX(context, x + destx, y + desty, GFX_COLOR_LTG);
                    break;

                case GFX_COLOR_DKG:
                    GfxPixelX(context, x + destx, y + desty, GFX_COLOR_DKG);
                    break;

                // check if PUT or OR - PUT is the assumed state
                case GFX_COLOR_WHT:
                    if ((context->mode & GFX_MODE_OR) == 0)
                    {
                        GfxPixelX(context, x + destx, y + desty, GFX_COLOR_WHT);
                    }
                    break;
            }
        }
    }
}


