
#include "gfx.h"
#include "rect.h"


void GfxSpriteBounce(SpriteT *sprite, BoundsT *bounds)
{
    if (sprite->xv > 0)
    {
        if (sprite->x + sprite->xv + sprite->pixelmap->width < bounds->right)
        {
            // OK to move to the right
            sprite->x += sprite->xv;
        }
        else
        {
            // would collide with the right side
            sprite->xv = -sprite->xv;
        }
    }
    else if (sprite->xv < 0)
    {
        if (sprite->x + sprite->xv > bounds->left)
        {
            // OK to move to the right
            sprite->x += sprite->xv;
        }
        else
        {
            // would collide with the right side
            sprite->xv = -sprite->xv;
        }
    }

    if (sprite->yv > 0)
    {
        if (sprite->y + sprite->yv + sprite->pixelmap->height < bounds->bottom)
        {
            // OK to move to the right
            sprite->y += sprite->yv;
        }
        else
        {
            // would collide with the side
            sprite->yv = -sprite->yv;
        }
    }
    else if (sprite->yv < 0)
    {
        if (sprite->y + sprite->yv > bounds->top)
        {
            // OK to move
            sprite->y += sprite->yv;
        }
        else
        {
            // would collide with the right side
            sprite->yv = -sprite->yv;
        }
    }
}

