
//
//  Cyborn OS - Copyright (C) 2004 Steve Gotthardt - Gotthardt Designs
//
//  This file is part of the Cyborn distribution.
//
//  Cyborn is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  Cyborn is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with Cyborn; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//  A special exception to the GPL can be applied should you wish to distribute
//  a combined work that includes Cyborn, without being obliged to provide
//  the source code for any proprietary components.
//


#include "gfx.h"



void
GfxVLine(SurfaceT *surface, GfxPT x, GfxPT y1, GfxPT y2)
{
    GfxPT y;
    unsigned char *byte;
    unsigned char mask;

    // get the initial offset
    if (y2 > y1)
    {
        y = y2 - y1;
        byte = surface->buffer + (x >> 2) + y1 * surface->cols;
    }
    else
    {
        y = y1 - y2;
        byte = surface->buffer + (x >> 2) + y2 * surface->cols;
    }


    // check for special cases - white and black
    switch (surface->fgPattern)
    {
        case GFX_COLOR_WHT:
            mask = gfxpixelnotch[x & 3];
            for (;;)
            {
                *byte = *byte & mask;
                if (!y) return;
                y--;
                byte += surface->cols;
            }
            break;


        case GFX_COLOR_BLK:
            mask = gfxpixelmask[x & 3];
            for (;;)
            {
                *byte = *byte | mask;
                if (!y) return;
                y--;
                byte += surface->cols;
            }
            break;

        default:
            mask = gfxpixelmask[x & 3];
            for (;;)
            {
                *byte = (*byte & ~mask) | (mask & surface->fgPattern);
                if (!y) return;
                y--;
                byte += surface->cols;
            }
    }
}

