
#include "lcd.h"



void
LcdArea(const LcdAreaT *area, unsigned char pattern)
{
    unsigned height;
    unsigned row;

    if (area)
    {
        row = LCD_ROWS - area->row - 1;

        // do the rows - all 'height' of them
        for (height = area->height; height; height--)
        {
            unsigned width = area->width;

            // point to the X address and write data to it
            LCD_INDEX(HD66421_REG_R2);  // x
            LCD_WRITE(area->col);

            // set the row - higher numbered rows first - display is upsidedown!
            LCD_INDEX(HD66421_REG_R3);  // y
            LCD_WRITE(row--);

            // index to the data access register - reg 4
            // the X index internally is automatically incremented and wraps
            LCD_INDEX(HD66421_REG_R4);

            // Ready to do an entire row
            while (width--)
            {
                LCD_WRITE(pattern);
            }
        }
    }
}




