
#include "lcd.h"



// Note that the display is upside down for the cybiko
// That translation will take place here in this file so that row 0 is
// at the top of the display


// full screen Clear
void
LcdClear(unsigned char pattern)
{
    unsigned char row, width;

    // point to the X address and write data to it - always column 0
    LCD_INDEX(HD66421_REG_R2);
    LCD_WRITE(0);

    // do all 100 rows from 99 through 0
    row = LCD_ROWS - 1;
    do
    {
        // set the row
        LCD_INDEX(HD66421_REG_R3);
        LCD_WRITE(row);

        // index to the data access register - reg 4
        // the X index internally is automatically incremented and wraps
        LCD_INDEX(HD66421_REG_R4);

        // all 40 bytes = 10 x 4
        for (width = 10; width; width--)
        {
            // Set the LCD - x auto increments
            // NOTE: if this was in onboard RAM or ROM, it would be too fast!
            LCD_WRITE(pattern);
            LCD_WRITE(pattern);
            LCD_WRITE(pattern);
            LCD_WRITE(pattern);
        }
    } while (row--);
}






