
#include "lcd.h"



// Note that the display is upside down for the cybiko
// That translation will take place here in this file so that row 0 is
// at the top of the display


// full screen dump/display
void
LcdDisplay(unsigned char *data)
{
    unsigned row;
    unsigned width;

    // point to the X address and write data to it - always column 0
    LCD_INDEX(HD66421_REG_R2);
    LCD_WRITE(0);

    // do all 100 rows from 99 through 0
    row = LCD_ROWS - 1;
    do
    {
        LCD_INDEX(HD66421_REG_R3);
        LCD_WRITE(row);

        // index to the data access register - reg 4
        // the X index internally is automatically incremented and wraps
        LCD_INDEX(HD66421_REG_R4);

        // 40 columns/bytes per row - data must be written one byte at a time
        for (width = 10; width; width--)
        {
            // blast out the data to the LCD
            LCD_WRITE(*data++);
            LCD_WRITE(*data++);
            LCD_WRITE(*data++);
            LCD_WRITE(*data++);
        }
    } while (row--);
}







