
;; Writes a row of data into the LCD
;; rewritten from c to gain about 10% increase


    .h8300s
    .text

; er0 = datapointer
; er1 = column to start putting data
; er2 = row of data to put (inverted in the lcd)
; er3 = width - how many bytes wide


    ; function name to export
    .global _LcdRow
    .global _Gfx8LcdRow


_LcdRow:

    ; reg 2 is for column register
    mov.b #0x2, r3h
    mov.b r3h, @0x600000:32	;point to col reg
    mov.b r1l, @0x600001:32	;put the col

    ; preset a reg to the data reg in the display chip
    mov.l #0x600001, er1

    ; reg 3 is for row
    mov.b #0x3,r3h
    mov.b r3h,@0x600000:32
    mov.b #0x63,r2h			;cybiko lcd is upside down - need to sub from 100
    sub.b r2l,r2h
    mov.b r2h,@er1			;use indirect thru pointer

    ; point to where the data should be written - reg 4
    mov.b #0x4, r3h
    mov.b r3h, @0x600000:32


lcdbyte:
    mov.b @er0+,r2l     ; from data to reg
    mov.b r2l, @er1     ; from reg to display
    dec.b r3l    		;
    bne   lcdbyte       ; keep going until all bytes are done
    rts


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; takes a row of 8bpp bytes
; er0 is datapointer to 8bpp bytes
; er1 is how many columns to draw
;; row and column already set up
_Gfx8LcdRow:
    mov.l   #0x600001, er3  ; for speed

lcdbyte8:
    mov.b @er0+,r2l     ; from data0 to reg
    shal  r2
    mov.b @er0+,r2l     ; from data1 to reg
    shal  r2
    mov.b @er0+,r2l     ; from data2 to reg
    shal  r2
    mov.b @er0+,r2l     ; from data3 to reg
    shal  r2
    mov.b r2h, @er3     ; from upper half of reg to display
    dec.b r1l           ;
    bne   lcdbyte8      ; keep going until all bytes are done
    rts

