

#include "rect.h"

// Order and assign the given coordinates
void RectMake(RectT *rect, short x, short y, short x2, short y2)
{
    if (x2 > x)
    {
        rect->x = x;
        rect->w = x2 - x + 1;
    }
    else
    {
        rect->x = x2;
        rect->w = x - x2 + 1;
    }

    if (y2 > y)
    {
        rect->y = y;
        rect->h = y2 - y + 1;
    }
    else
    {
        rect->y = y2;
        rect->h = y - y2 + 1;
    }
}



// check for point inside of the rect
short RectInside(RectT *rect, short x, short y)
{
    return (x - rect->x < rect->w && y - rect->y < rect->h);
}




// do these rectangles intersect - useful for collision detection
short RectCollide(RectT *rect, RectT *rect2)
{
    if (rect->x > rect2->x + rect2->w) return 0;
    if (rect->x + rect->w < rect2->x) return 0;
    if (rect->y > rect2->y + rect2->h) return 0;
    if (rect->y + rect->h < rect2->y) return 0;

    return 1;  // collision
}



