
#include <string.h>
#include "surface.h"


// move one surface onto another at the given col and row
// note the col is not in pixels; its in byte aligned 4 pixels at a time
// Typically the src surface is smaller than the dst surface
void
SurfaceBlit(SurfaceT *src, SurfaceT *dst, unsigned col, unsigned row)
{
    unsigned srcrow;
    char *srcbuffer, *dstbuffer;

    // start at beginning of the buffer
    srcbuffer = src->buffer;

    // start at offset row and column in destination
    dstbuffer = dst->buffer + row * dst->cols + col;


    // for all of the rows put out all of the columns
    for (srcrow = src->rows;;)
    {
        memcpy(dstbuffer, srcbuffer, src->cols);

        if (--srcrow == 0) break;

        dstbuffer += dst->cols;
        srcbuffer += src->cols;
    }
}



