#include <string.h>
#include "surface.h"

// set a filled rectangle on a surface - fast because it uses columns
// columns are byte aligned and 4 pixels wide


void
SurfaceRect(SurfaceT *surface,
unsigned col,       // what column to start at. Each col is 4 pixels
unsigned row,       // what row to start at
unsigned width,     // how many columns wide
unsigned height,
unsigned char pattern)    // fill pattern
{
    char *sectionbuffer;

    // optimize if the width is full width
    if (width == surface->cols)
    {
        sectionbuffer = surface->buffer + surface->cols * row;
        memset(sectionbuffer, pattern, surface->cols * height);
    }
    else
    {
        sectionbuffer = surface->buffer + col + surface->cols * row;

        // how many rows to do = height
        while (height--)
        {
            memset(sectionbuffer, pattern, width);
            sectionbuffer += surface->cols;
        }
    }
}


