#include <string.h>
#include "surface.h"


// Scroll one surface 
// amount: how many lines to scroll
void
SurfaceScroll(SurfaceT *surface, unsigned amount, SurfaceScrollT direction)
{
    switch (direction)
    {
        case SURFACE_SCROLL_UP:
        // use memmove because source and destination may overlap
        memmove
        (
            surface->buffer, 
            surface->buffer + (amount * surface->cols),
            (surface->rows - amount) * surface->cols
        );

        // clear the rows below
        memset
        (
            surface->buffer + (surface->rows - amount) * surface->cols,
            surface->bgPattern,
            surface->cols * amount
        );
        break;
            
        case SURFACE_SCROLL_DOWN:
        // use memmove because source and destination may overlap
        memmove
        (
            surface->buffer + (amount * surface->cols),
            surface->buffer, 
            (surface->rows - amount) * surface->cols
        );

        // clear the rows above
        memset
        (
            surface->buffer,
            surface->bgPattern,
            surface->cols * amount
        );
        break;
    }            
        
            
}



