#include "sfx.h"

// 32 ticks = a quarter note = 1 beat

MusicNoteT *sfx_song;


typedef enum
{
    SFX_SONG_END,
    SFX_SONG_PLAY,
} SfxSongModeT;



extern SfxSongModeT timer_songmode;
extern BeatTicksT   timer_noteticks;

// tick interrupt handler calls this function every tick
void NoteInterrupt(void)
{
    if (timer_noteticks)
    {
        // keep decrementing
        timer_noteticks--;
    }
    else  // done with the ticks - this note is over
    {
        // when we get here, one note has played
        // Is it the last note in a song or not or just a note?
        if (timer_songmode == SFX_SONG_PLAY)
        {
            if (++sfx_song->note)
            {
                // keep playing
                SfxNote(sfx_song);
            }
            else
            {
                timer_songmode == SFX_SONG_END;
                SfxStop();
            }
        }
        else
        {
            // not playing a song, must have been just one note
            SfxStop();
        }
    }
}




SfxSong(MusicNoteT *song)
{
    sfx_song = song;
    timer_songmode = SFX_SONG_PLAY;

    // start /  restart interrupt for playing note
}


// the frequency is NOT the midi note - use: SFX_MIDI_XXX for the period OR
// use any value for ticks - a value of zero ticks will not stop
// sfx_tone(MIDI_NOTE_69, TICKS_PER_BEAT(1));  // one beat, quarter note
void
SfxNote(MusicNoteT *note)
{
    // use low level sound generator - changes the tone now

    // put the note into the timer for sound
    TM1[xx] = note->note;

    // set the timer for the number of ticks before the next sound is needed
    timer_noteticks = note->ticks;

}




