


#include "events.h"
#include "ipc.h"
#include "cyborn.h"

typedef struct
{
    UINT16 interval;
    UINT16 count;
} TimerIntervalT;

typedef struct
{
    TimerIntervalT timer;
    ApplicationIdT id;
} EventTimerT;



void
EventTimerSet(ApplicationIdT id, TimeIntervalT *interval)
{
    CybornStatusT status;


// or
    status = TimerAdd(TIMER_TYPE_EVENT, interval, id);

    // also add blocking events. See: sleep
    //status = TimerAdd(TIMER_TYPE_BLOCK, interval, task);

// or
    status = TimerEvent(callback, arg, interval);

// or
    event = malloc(sizeof(EventTimerT);

    // will the compiler figure this out???
    event->timer = *interval;

    event->id = id;

    // Launch a new task that will do the timing intervals
    task = TaskCreate(EventTimerTask, event, stacksize, TASK_PRI_HIGH);


    // that was fun. now the task that is running and watching for timers
}




// Task that watches for timer events and alerts the application that it has
// transpired
void
EventTimerTask(void *args)
{
    EventTimerT *event = (EventTimerT *)args;


    // need a timer interval struct
    // need an application event queue to send event to


    // This task needs to send a note to a queue that is waiting
    for (;;)
    {
        // wait for the next time
        sleep(event->timer.interval);

        // some timer is ready - the note has the application id
        NoteWrite(event->id, TIMER_EVENT);

        // enough?
        if (event->timer.count && event->timer.count-- == 0) break;
    }

    free(event);

    // exit and clean up after sending events
    TaskExit();
}





