#ifndef _CY6411V2_H_
#define _CY6411V2_H_

// This is the define file for the cybiko classic v2

// The cybiko classic uses the H8s 2241 - uses this header file
#include "2245s.h"



// clock speed
#ifdef OVERCLOCKED      // only use if crystal was replaced
#define CYBIKO_CLOCK_HZ 18432000
#else
#define CYBIKO_CLOCK_HZ 11592000
#endif



// RAM, Progam Flash, Data Flash, RTC
// 256 Kbytes RAM
// 256 Kbytes Multipurpose Program Flash - SST 39VF020
// 512 Kbytes Data Flash - serial access Atmel AT45DB041A


// The chip select lines
#define CYBIKO_BOOT_BASE    0x000000
#define CYBIKO_FLASH_BASE   0x100000    // chip select 0
#define CYBIKO_RAM_BASE     0x200000    // chip select 1
#define CYBIKO_EXRAM_BASE   0x400000    // chip select 2
#define CYBIKO_DISPLAY_BASE 0x600000    // chip select 3
#define CYBIKO_KEYS_BASE    0xE00000    // no chip select


// The CPU is set to Mode 6 - on-chip ROM enabled


// compatible with this version of bios:
#define CYBIKO_ROM_VERSION  117



#endif
