#ifndef _BOTTOM_H_
#define _BOTTOM_H_



///////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////// Bottom Half
// Bottom half processing can be done here in immediate tasks -
// The scheduling is turned off - the timer is stopped - to do these tasks

typedef struct bottomhalf
{
    struct bottomhalf   *next;
    EntryT              entry;
    void                *parameter;
} BottomHalfT;




// ISR Context
// Use it in an ISR
// This should be the last line in an isr
//  Example
#if 0
BottomHalfT BHScheduler;
BottomHalfRegister(&BHScheduler, scheduler, interruptmask);

Timer Interrupt(void)
{
    // clear interrupt

    // need to run the scheduler
    BottomHalfDo(&BHScheduler);
}
#endif


// ISR context
void inline
BottomHalfDo(BottomHalfT *dsr);



// Top priority - use as entry to a task
void
BottomHalfTask(void);



#endif
