    .h8300s     ;generate H8S code

    .text

;TODO: put in a define for BOOT to include the following header

.long       0x1234ABCD  ;cybiko bootmonitor looks for this and the
.long       _start      ;start location entry point

.global     _start      ;the linker is looking for this


;by the time we get here, the stack is set up and the display has been
;initialized, a timer is started at 50Hz.

_start:
    sub     e1,             e1
    mov     #_bss_start,    er2     ;zero the bss
zerobcc:
    cmp     #_end,          er2     ;check for no data
    beq     zerodone
    mov     e1,             @er2    ;put the zero
    adds    #0x2,           er2     ;point to next word
    bra     zerobcc

zerodone:
    ;need to move the .data section to RAM
    ; for now the .data section is in RAM. Later when the program is split up
    ; with the program in flash, the new routine will have to move the data
    ; section to the RAM

    jsr     _main                   ;start the program


    ;should have some kind of atexit area to support atexit


    ;cleanup
    ; jump back to the beginning - where the reset vector points to
    jmp     @@0                     ;system reset


