


#include "kernel.h"


// These need to be global so that the stack has no locals on it
// That allows a context switch to be made
static TaskT   *ChangeTask;
static UINT16   pattern;
static UINT16   keystroke;



// ISR polling the keyboard
// This ISR does not have to be accurate, but something around 20Hz
// Things done in here:
//  >> check/poll the keyboard for a change
void
KeyboardISR(void)
{
    // grab the pattern
    pattern = KeyboardRead();

    // has a change occured?
    if (pattern != keystroke)
    {
        // send the message to the current application message buffer
        if (pattern)
        {
            ChangeTask = NoteWriteIsr(OSQueue, EVENT_KEY_DOWN | pattern);
        }
        else
        {
            ChangeTask = NoteWriteIsr(OSQueue, EVENT_KEY_UP | keystroke);
        }

        // assign the new keystroke
        keystroke = pattern;

        if (ChangeTask)
        {
            CurrentContext->stackpointer = er7;

            // assign new current task
            CurrentContext = change;

            // load the new stack pointer
            er7 = change->stackpointer;
        }
    }
}

