
// for ticks,
#include "cyborn.h"

// Tasks



// Construct a New Task - Not ready to run - use ScheduleAdd to place on
// scheduling queue
TaskT *TaskCreate(  AddressT        entry,
                    unsigned long   StackSize,
                    void            *parameter,
                    PriorityT       priority)
{
    TaskT *task;

    // figure and allocate memory
    task = (TaskT *)malloc(StackSize + sizeof(TaskT));
    if (task)
    {
        // fill in and clear all of the details
        task->priority  = priority;
        task->parameter = parameter;

        // put the stack pointer at the end of the block
        task->stackpointer = (unsigned char *)&task->stackframe + StackSize;

        // Somehow the task must have a stack loaded so that a context
        //  switch will start the task and go to the entry
        // Put the entry on the 'stack'
        // move it back by 4 chars
        task->stackpointer -= 4;

        // now put the entry on the 'stack'
        *(AddressT *)(task->stackpointer) = entry;

        // register this task with the scheduler...
        ScheduleRegister(task);
    }

    return task;
}



// Exit from task
// Must give up all flags, queues, etc...
CybornStatusT
TaskExit(void)
{
    ScheduleDelete(CurrentTask);

    // stop being the owner of any flags!!

    if (TimerRemove(CurrentTask) == CYBORN_STATUS_OK)
    {
        // found it was blocked on a timer
    }


    // need to release memory
    return CYBORN_STATUS_OK;
}




